var sServerURL="https://dsservices.aizo.com";


var cloudService = {
    makePostCall:function(sFunction,data) {
    	
    	
    	
        lInfo.logln("http post reuqest " + sFunction);
        lInfo.logln("             body " + data);
        try {
        
        	var handle = new WebserviceConnection();
        	
        	handle.request(sFunction, 'POST', {'Content-Type':'application/json','NotificationTextIsUrlEncodedUtf7':'true'},
        			data
        				, function(code, retdata) {
        				if (code === 200) {
                            lInfo.logln( ': OK [' + code + ']');
                        } else {
                            lWarn.logln(': FAILED! Server replied: "' + code + '"');
                        }
                        lInfo.logln(': body [' + retdata + ']');
        			});
        	
            return;
        } catch (e) {
            lWarn.logln("Exception during http post reuqest " + sFunction+": ");
            for (var i in e) {
                lWarn.logln(i + ': ' + e[i]);
            }
        }
        return;
    },
    makeGetCall:function(sFunction,func,options) {
        var extraheaders = [];
        lInfo.logln("http get reuqest " + sFunction);
        try {
            if (options==null)
                options= { 'debug' : 0};
            else
                options.debug=0;
            
            var handle = new WebserviceConnection();

            handle.simplerequest(sFunction, 'GET', function(code, data) {
            	
                if (code === 200) {
                    lInfo.logln( ': OK [' + code + ']');
                } else {
                    lInfo.logln(': FAILED! Server replied: "' + code + '"');
                }
                lInfo.logln(data);
                func(JSON.parse(data));
            });
            
            return;
        } catch (e) {
            lWarn.logln("Error during upload: ");
            for (var i in e) {
                lWarn.logln(i + ': ' + e[i]);
            }
        }
        return 0;
    },
    getOSPToken:function() {
		return Property.getNode('/scripts/remote-connectivity/OSPToken').getValue();
    },
    getCloudEmail:function() {
		return Property.getNode('/scripts/remote-connectivity/username').getValue();
    },
    getMyDSID:function(){
		return Property.getProperty('/system/dSID');			
	},
    fetchNotificationList:function(func) {
    	//GetMobileApps
    	var url='/public/accessmanagement/v1_0/RemoteConnectivity/GetMobileApps?token='+this.getOSPToken()+'&email='+ this.getCloudEmail();
    	this.makeGetCall(url,func);
    },
    sendNotification:function(uuida,text) {
    	var url='/public/notification/v1_0/SendNotification/SendPushNotification?notificationID=PUSH_NOTIFICATION_DSS_EVENT_PUSH&token='+this.getOSPToken()+'&languageCode=de-DE';
    	var body='{"MobileAppUUIDList": [';
    	var fFirst=true;
    	for (var iIndex=0;iIndex<uuida.length;iIndex++) {
    		if (!fFirst)
    			body=body+',';
    		body=body+'"' + uuida[iIndex] + '"';
    		fFirst=false;
    	}
    	body=body+'],"NotificationKeyValueList": { "Text": "'+text+'" } }';
    	this.makePostCall(url,body);
    }
};